"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.constantCase = exports.camelCase = exports.upperFirst = exports.formatInsideUnderscores = exports.constantCaseAll = exports.sqlJsonBuildObjectFromFragments = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _pgSql = require("pg-sql2");

var _pgSql2 = _interopRequireDefault(_pgSql);

var _upperFirst = require("lodash/upperFirst");

var _upperFirst2 = _interopRequireDefault(_upperFirst);

var _camelCase = require("lodash/camelCase");

var _camelCase2 = _interopRequireDefault(_camelCase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sqlJsonBuildObjectFromFragments = exports.sqlJsonBuildObjectFromFragments = function sqlJsonBuildObjectFromFragments(fragments) {
  return _pgSql2.default.fragment`
    json_build_object(
      ${_pgSql2.default.join(fragments.map(function (_ref) {
    var sqlFragment = _ref.sqlFragment,
        alias = _ref.alias;
    return _pgSql2.default.fragment`${_pgSql2.default.literal(alias)}, ${sqlFragment}`;
  }), ",\n")}
    )`;
};
var constantCaseAll = exports.constantCaseAll = function constantCaseAll(str) {
  return str.replace(/[^a-zA-Z0-9_]+/g, "_").replace(/[A-Z]+/g, "_$&").replace(/__+/g, "_").replace(/^[^a-zA-Z0-9]+/, "").replace(/^[0-9]/, "_$&") // GraphQL enums must not start with a number
  .toUpperCase();
};

var formatInsideUnderscores = exports.formatInsideUnderscores = function formatInsideUnderscores(fn) {
  return function (str) {
    var matches = str.match(/^(_*)([\s\S]*?)(_*)$/);
    if (!matches) {
      throw new Error("Impossible?"); // Satiate Flow
    }

    var _matches = (0, _slicedToArray3.default)(matches, 4),
        start = _matches[1],
        middle = _matches[2],
        end = _matches[3];

    return `${start}${fn(middle)}${end}`;
  };
};

var upperFirst = exports.upperFirst = formatInsideUnderscores(_upperFirst2.default);
var camelCase = exports.camelCase = formatInsideUnderscores(_camelCase2.default);
var constantCase = exports.constantCase = formatInsideUnderscores(constantCaseAll);
//# sourceMappingURL=utils.js.map